=== modified file 'doc/dev/architecture.rst'
--- doc/dev/architecture.rst	2010-02-24 08:19:50 +0000
+++ doc/dev/architecture.rst	2010-02-15 02:31:08 +0000
@@ -349,59 +349,6 @@
 Worksheets
 ==========
 
-Worksheets provide a way for users to be able to attempt a set of coding 
-exercises along with accompanying instructions. In the past worksheets were 
-created directly using an XML format, but this has been deprecated in favour 
-of being generated automatically from reStructuredText.
-
-Worksheets are now stored in the database as a :class:`Worksheet` object (see 
-:file:`ivle/database.py`).  This allows them to be treated with the same 
-access permissions available to other objects and lays down the ground work 
-for providing versioned worksheets.
-
-
-Exercises
----------
-
-When users submit an exercise, the user's solution is tested against a series 
-of test cases which can be used to check if a solution is acceptable. Almost 
-all the behavior for exercises is contained within 
-:file:`ivle/webapp/tutorial/test/TestFramework.py`.
-
-.. note::
-    The TestFramework module is one of the oldest and most complicated in 
-    IVLE, largely taken directly from the IVLE prototype. As such it has a 
-    design that doesn't quite match the current architecture of IVLE, such as 
-    using slightly different terminology and having a few testing facilities 
-    that are untested or untested. It requires a substantial rewrite and 
-    comprehensive test suite to be developed.
-
-At the top level exists the :class:`Exercise` object (known as ``TestSuite`` 
-in :file:`TestFramework.py`). This object encompasses the entire collection of 
-tests for a given exercise and details such as the exercise name, provided 
-solution and any "include code" (Python code available for all test cases, but 
-not the user's submission).
-
-Each exercise may contain one or more :class:`TestSuite` objects (known as 
-``TestCase`` in :file:`TestFramework.py`. A test suite is a collection of 
-tests that run with some sort of common input - be that stdin contents, a 
-virtual file system configuration (presently disabled), inputs to particular 
-function or defining the contents of one or more variables. A test suite will 
-typically run until the first test case fails, but can be configured to 
-continue running test cases even after one has failed. Exceptions raised by 
-submitted code will typically cause the test to fail except if it is marked as 
-an "allowed exception".
-
-Individual units to be tested (something that can pass or fail) are contained 
-within :class:`TestCase` objects (known as ``TestCaseParts`` in 
-:file:`TestFramework.py`). A test case can test the value of source code text, 
-the function return value (Will be ``None`` for scripts), stdout contents, 
-stderr contents, name of any raised exception and contents of the virtual file 
-system (presently disabled) of code submitted by users. These checks are 
-contained in a :class:`TestCasePart`. In addition, a normalisation function or 
-custom comparison function can be used instead of comparing the raw values 
-directly.  By default, the value of each check will be ignored unless 
-overidden by a test case part.
 
 Database
 ========

=== modified file 'doc/man/scripts.rst'
--- doc/man/scripts.rst	2010-02-24 09:07:04 +0000
+++ doc/man/scripts.rst	2009-12-10 09:47:38 +0000
@@ -127,10 +127,6 @@
 <NEWSEMESTER>`` with a copy of the worksheets from the offering specified by 
 ``<OLDSUBJECTCODE> <OLDYEAR> <OLDSEMESTER>``.
 
-.. note::
-    Admins may also clone worksheets from the offering administration panel
-    in the web interface.
-
 
 ivle-config
 -----------
@@ -282,10 +278,6 @@
 
 Lists all users in the IVLE database.
 
-.. note::
-    Users may also be listed and administered through the web interface,
-    from the *Users* item in the IVLE menu.
-
 .. cmdoption:: -n, --names
 
     Print only each user's login name

=== modified file 'doc/man/tour.rst'
--- doc/man/tour.rst	2010-02-24 07:22:43 +0000
+++ doc/man/tour.rst	2010-02-18 00:02:51 +0000
@@ -34,8 +34,8 @@
 A student's view
 ================
 
-Begin by logging into IVLE as a student (username: ``studenta``, password:
-``password``).
+Begin by logging into IVLE as a student (username: 'studenta', password:
+'password').
 
 Files
 -----
@@ -45,79 +45,79 @@
 which is always visible in IVLE. Clicking the IVLE logo always returns you to
 the home screen.
 
-The user ``studenta`` is enrolled in several subjects, and has several files
+The user "studenta" is enrolled in several subjects, and has several files
 already in her Subversion repository, but they aren't immediately accessible.
 
-First, click all of the *Checkout* buttons, to check out the Subversion
+First, click all of the "Checkout" buttons, to check out the Subversion
 repositories. Now you can explore the sample files, for example, in the
-``stuff`` directory.
+"stuff" directory.
 
-Go into the ``stuff`` directory and left-click the file ``hello.py``. This will
+Go into the "stuff" directory and left-click the file "hello.py". This will
 open the build-in text editor, which lets you modify the file. Along the top,
-there is a button marked *Serve*. Clicking this will *run* the Python code as
+there is a button marked "Serve". Clicking this will *run* the Python code as
 a CGI application -- this should open a new window which reads "Hello,
-world!". You can also click *Run*, which will run the program in the built-in
+world!". You can also click "Run", which will run the program in the built-in
 Python console (which pops up from the bottom of the screen). This will be
 much uglier, printing the CGI output.
 
-* *Serve* runs Python programs as CGI applications, showing their web output.
-* *Run* runs Python programs as command-line applications.
+* "Serve" runs Python programs as CGI applications, showing their web output.
+* "Run" runs Python programs as command-line applications.
 
 Note that you can also use the console at the bottom of the screen as a
 generic Python console, whenever you wish.
 
-You can also serve other files, such as HTML files (try ``Welcome to
-IVLE.html``). This will just present them as normal web pages.
+You can also serve other files, such as HTML files (try "Welcome to
+IVLE.html"). This will just present them as normal web pages.
 
 Files also have full Subversion histories. If you click on a file in the file
-view (such as ``hello.py``), and go to *More Actions ‣ Subversion ‣ View Log*,
+view (such as "hello.py"), and go to More Actions -> Subversion -> View Log,
 you will see the history of a file, and be able to "select" then view a "diff"
-of the file. If you edit a file, you need to commit it (*More Actions ‣
-Subversion ‣ Commit*). If you create a new file (*More Actions ‣ Directory
-actions ‣ New file*), you need to add it (*More Actions ‣ Subversion ‣ Add*),
+of the file. If you edit a file, you need to commit it (More Actions ->
+Subversion -> Commit). If you create a new file (More Actions -> Directory
+actions -> New file), you need to add it (More Actions -> Subversion -> Add),
 then commit.
 
 Submissions
 -----------
 
 This student has already completed a project, and is ready to submit it. Go
-into the *Intermediate IVLE ‣ mywork* directory. Select ``phase1.html`` and
-choose *More Actions ‣ Publishing ‣ Submit*. This takes you to the Submit
+into the Intermediate Ivle -> mywork directory. Select "phase1.html" and
+choose More Actions -> Publishing -> Submit. This takes you to the Submit
 Project screen.
 
-Choose to submit to Phase 1, and click *Submit Project*. You should see a page
-telling you the submission was successful, with a link to *Verify*. Verify
+Choose to submit to Phase 1, and click Submit Project. You should see a page
+telling you the submission was successful, with a link to "verify". Verify
 shows you exactly which files were submitted, and their contents at the time
 of submission (if the files have changed since then, you'll still see the
 submitted version). You should verify after each submission -- you can verify
 any submitted project from the subject page.
 
-If you go into the *Intermediate IVLE ‣ group1* directory, you will be able
-to make a group submission to Phase 2 (which is a group project). Note that
-the Phase 3 submission has already closed.
-Also note that the file here (``phase2.html``) was edited by studenta and
+If you go into the Intermediate Ivle -> group1 directory, you will be able to
+make a group submission to Phase 2 (which is a group project). Note that the
+Phase 3 submission has already closed.
+Also note that the file here ("phase2.html") was edited by studenta and
 studentb collaboratively, as you can see in the project's revision log.
 
 Worksheets
 ----------
 
-Click on *Intermediate IVLE – Subject Home* from the home screen (or, from
-the IVLE pulldown menu, choose *Subjects* and select Intermediate IVLE). There
-is one worksheet, Worksheet Basics. Clicking this takes you to the worksheet,
+Click on Intermediate Ivle -> Subject Home from the home screen (or, from the
+IVLE pulldown menu, choose Subjects and select Intermediate Ivle). There is
+one worksheet, Worksheet Basics. Clicking this takes you to the worksheet,
 where students are challenged by Python questions.
 
 After reading the worksheet, attempt the first simple programming question,
-which is to write the "Hello world" program.
+which is to write the Hello world program.
 
-First, click *Submit* without writing any code, and note that the system
+First, click Submit without writing any code, and note that the system
 automatically runs a test case, which fails. Now change the code to be "almost
-right" (for example, write ``Hello world`` instead of ``Hello, world!``), and
-press *Submit* again. It will tell you that you almost got it right. In this
+right" (for example, write "Hello world" instead of "Hello, world!"), and
+press Submit again. It will tell you that you almost got it right. In this
 way, the IVLE test framework can show users that they're on the right track.
-If you get it exactly right and click *Submit* a third time, you will pass the
+If you get it exactly right and click Submit a third time, you will pass the
 test.
 
-Note that you can also click *Run*, and it will execute your solution in the
+Note that you can also click "Run", and it will execute your solution in the
 Python console. This doesn't cost you an "attempt", nor does it run the test
 cases. It just lets you test it out for yourself before making an official
 submission.
@@ -140,29 +140,28 @@
 A lecturer's view
 =================
 
-Log into IVLE as a lecturer (username: ``lecturer``, password: ``password``).
-Many of these things are also possible as a tutor (try username: ``tutor``,
-password: ``password``).
+Log into IVLE as a lecturer (username: 'lecturer', password: 'password'). Many
+of these things are also possible as a tutor (try username: 'tutor', password:
+'password').
 
 Being a lecturer or tutor is a per-subject privilege, so it only applies to
 certain subjects. All of your special powers are under the subject home for
 the subjects you are a tutor in. Note that everything a lecturer can do, an
 admin can also do, for all subjects in the system.
 
-Click *Intermediate IVLE – Subject home* (the one which does not display a
-semester -- implying the currently active semester). From here, you will see
-largely the same view as a student, but with more buttons. *Change details*
-allows you to modify the subject properties. *Administer enrolments* allows
-you to add existing IVLE users as students or tutors of the subject you are
-teaching, change the roles of existing members, and revoke enrolments.
+Click "Intermediate IVLE - Subject home". From here, you will see largely the
+same view as a student, but with more buttons. "Change details" allows you to
+modify the subject properties. "Enrol users" allows you to add existing IVLE
+users as students or tutors of the subject you are teaching (this is currently
+an irreversible action).
 
 Managing projects
 -----------------
 
-Click *Manage projects* to go to the project management screen. Note that the
+Click "Manage projects" to go to the project management screen. Note that the
 3 projects are grouped into "Solo projects" (projects submitted by each
 individual student) and "Group projects". Try adding a new Solo project, by
-clicking on *Add a new project* within that box. The fields should be fairly
+clicking on "Add a new project" within that box. The fields should be fairly
 self-explanatory.
 
 .. warning::
@@ -174,10 +173,10 @@
 box. This means students will get into groups of 3 to submit Phase 2, and then
 the same group will submit Phase 3.
 
-Clicking *Manage groups* lets you put students into groups for a given project
+Clicking "Manage groups" lets you put students into groups for a given project
 set.
 
-Click *Add a new project set* and enter a group size of 6. Then, create a
+Click "Add a new project set" and enter a group size of 6. Then, create a
 project in the new set. Each student must get into a new group for each
 project *set*. Note also that the groups will share a Subversion repository
 for all projects in a set, but if you create a new set, the students will have
@@ -195,9 +194,9 @@
 commits, you can examine a student's work by simply checking out the correct
 revision of the repository.
 
-From the offering page, click *View submissions* under the project of interest.
+From the offering page, click "View submissions" under the project of interest.
 This takes you to a page which lists the latest submissions from every student
-(presumably you will just see the submission made by ``studenta`` earlier in
+(presumably you will just see the submission made by "studenta" earlier in
 this tour). Next to each submission is a command line, beginning with
 ``svn co``. For instance, you might see the line::
 
@@ -205,7 +204,7 @@
 
 Paste this line into a command-line (or, if you use a GUI Subversion client,
 use the username, revision and URL given). Subversion will likely prompt for a
-password. For the sample data, this password is ``password``, but in general, it
+password. For the sample data, this password is "password", but in general, it
 will **not** be your normal IVLE password. You can learn your Subversion
 password by opening a Console in IVLE and typing::
 
@@ -224,36 +223,36 @@
 Managing worksheets and exercises
 ---------------------------------
 
-Returning to the subject home page, click *Manage worksheets*. On this page,
-you will see all of the worksheets for the subject. Here you can edit
-worksheets, add new ones, and re-order them. You can also edit any worksheet
-from its own page.
+Return to the subject home page. Click "Manage worksheets". On this page, you
+will see all of the worksheets for the subject. Here you can edit worksheets,
+add new ones, and re-order them. You can also edit any worksheet from its own
+page.
 
 To get an idea of what a worksheet looks like in edit mode, click the edit
 action (pencil) next to "Worksheet Basics".
 
-* The *URL name* is the name of the worksheet as it appears in URLs.
-* The *Assessable* checkbox will make the exercises in the worksheet count
+* The "URL name" is the name of the worksheet as it appears in URLs.
+* The "Assessable" checkbox will make the exercises in the worksheet count
   towards each student's worksheet mark, if checked. Uncheck it for
   informational worksheets.
-* The *Format* selection controls the format used to write the worksheet in
-  the box below. Leave it on *reStructuredText* unless you have a reason not
+* The "Format" selection controls the format used to write the worksheet in
+  the box below. Leave it on "reStructuredText" unless you have a reason not
   to.
 
 Now, you can edit the worksheet content in reStructuredText. The existing text
 briefly explains this format. See `A ReStruecturedText Primer
 <http://docutils.sourceforge.net/docs/user/rst/quickstart.html>`_ for a full
-guide. Note that the exercises themselves are not defined in the worksheet.
-They are separate resources, which can be shared across subjects. Exercises
-can be embedded with a line like this::
+guide. Note that the exercises themselves are not in the worksheet. They are
+separate resources, which can be shared across subjects. Exercises can be
+embedded with a line like this::
 
  .. exercise:: factorial
 
-Click *Manage exercises* to see the exercises (in the sample data, just
-``factorial``). An exercise is a very complex thing, due to the fact that it
+Click "Manage exercises" to see the exercises (in the sample data, just
+"factorial"). An exercise is a very complex thing, due to the fact that it
 runs automated testing on the student code. The details are outside the scope
 of this tour. Hopefully, you can figure out how they work by examining the
-existing ``factorial`` exercise.
+existing "factorial" exercise.
 
 If you are game enough, create a new worksheet from scratch. If you are
 *really* game, create a new exercise for your worksheet.
@@ -261,25 +260,22 @@
 An administrator's view
 =======================
 
-Log into IVLE as an admin (username: ``admin``, password: ``password``).
+Log into IVLE as an admin (username: 'admin', password: 'password').
 
 Administrator users in IVLE have significant privileges. Note, however, that
 for technical reasons, admins cannot read or write other users' files. This
 requires root access on the machine IVLE is installed on.
 
-Administering users
--------------------
-
 Firstly, pull down the IVLE menu (top-left). There is an additional item for
-admins -- the *Users* page. This lists all users with an account in IVLE.
+admins -- the "Users" page. This lists all users with an account in IVLE.
 Clicking on a username takes you to the user's profile page. Try it with the
-user ``lecturer``.
+user 'lecturer'.
 
 The profile page is exactly the same as the user himself would see it, but
-with a few more buttons on the side. *Change password* is the same as the
-user's own *Change password* page. However, *Reset password* is a special
+with a few more buttons on the side. "Change password" is the same as the
+user's own "Change password" page. However, "Reset password" is a special
 admin page which lets you change a user's password without knowing the old
-one. *Administer user* also lets you change administrative settings for the
+one. "Administer user" also lets you change administrative settings for the
 user, such as their full name (more formal than display name, which the user
 themselves can change) and student ID. You can also add/remove admin status
 for, or disable/enable (i.e., ban from IVLE) any user (except yourself, of
@@ -289,70 +285,10 @@
    Use this with care. Making a user an admin gives them complete control over
    the system. They could even revoke *your* admin rights!
 
-Administering subjects and offerings
-------------------------------------
-
-Admin users also enjoy the same privileges as lecturers, for all subject
-offerings on the system. In addition, admins can enrol users in an offering as
-lecturers (this is the only way to become a lecturer), and change or delete a
-lecturer's enrolment. Go to the subject page for Advanced IVLE and enrol the
-user ``lecturer`` as a lecturer in the subject.
-
-Admins can also administer subjects. Here it is important to distinguish
-between a "subject" (a course on a specific topic which is repeated over a
-number of semesters or years) and an "offering" (a particular instance of a
-subject, for one semester). Lecturers can administer *offerings* they are
-enrolled in, but not *subjects*.
-
-As an admin, go to the *Subjects* page. You will see a link *Manage subjects
-and semesters*. The list at the top of the page shows all registered
-subjects. Click *Create new subject* to create a brand new subject (i.e., a
-new course). Call it "Introduction to Programming", with the URL name
-``intro-prog`` and subject code 200101.
-
-Now we have created a *subject* but not an *offering*, so nobody will be able
-to teach or enrol in this subject. From the "Introduction to Programming"
-page, click *Create new offering*. Select the semester in which the subject
-will be first taught. If you wish to create the first offering of a semester
-(e.g., 2011 semester 1), you will have to create a new semester first. Type
-in a subject description. (Note that each offering has an independent
-description.) Once you have created an offering, you can enrol lecturers, and
-they can in turn enrol students.
-
-Lecturers can take over administration duties of an offering (such as editing
-the description and managing projects), however it remains the admin's duty to
-administer the subjects, including creating new offerings each semester and
-enrolling lecturers.
-
-Administering semesters
------------------------
-
-An important duty of the administrator is controlling the *state* of each
-semester. Return to the *Manage subjects and semesters* page. Note the
-*Semesters* table contains a list of all known semesters, and whether they are
-"past", "current" or "future".
-
-.. note::
-   IVLE could automatically create and manage semesters based on the system
-   clock, but it presently does not. That is because your institution may have
-   a different concept of a "semester" to ours. (For example, what are the
-   semester start and end dates?) IVLE has therefore been designed to require
-   admins to manually activate new semesters and disable old ones.
-
-In the sample data, 2009 semester 2 is the "current" semester. Let us assume
-that we are moving into the start of 2010. Edit 2009 semester 2 and set its
-state to "Past". Then, edit 2010 semester 1 and set its state to "Current".
-This affects the system in several ways. Mainly, it just changes the UI for
-all users, in terms of which offerings are presented as "current".
-
-.. warning::
-   Marking a semester as anything other than "current" will make it impossible
-   for students enrolled in offerings for that semester to submit projects.
-   Only do this after the semester has fully closed.
-
-It is possible for multiple semesters to be marked as "current", if this is
-desired. Therefore, there is no need to disable one semester before enabling
-another.
+Admin users also enjoy the same privileges as lecturers, for all subjects on
+the system. In addition, admins can enrol users in a subject as lecturers
+(this is the only way to become a lecturer). Go to the subject page for
+"Advanced IVLE" and enrol the user "lecturer" as a Lecturer in the subject.
 
 Admin scripts
 -------------

=== modified file 'examples/db/sample.sql'
--- examples/db/sample.sql	2010-02-24 11:44:41 +0000
+++ examples/db/sample.sql	2010-02-18 00:02:51 +0000
@@ -256,12 +256,12 @@
 
 ALTER TABLE offering DISABLE TRIGGER ALL;
 
-INSERT INTO offering (offeringid, subject, semesterid, description, url, groups_student_permissions, show_worksheet_marks, worksheet_cutoff) VALUES (1, 1, 1, 'This subject will introduce you to the basics of IVLE.', 'http://www.ivle.org/example/101', 'none', false, NULL);
-INSERT INTO offering (offeringid, subject, semesterid, description, url, groups_student_permissions, show_worksheet_marks, worksheet_cutoff) VALUES (2, 2, 2, 'Enhancing your understanding of IVLE''s usage and operation, this subject will consolidate and expand your general IVLE knowledge.', 'http://www.ivle.org/example/102', 'none', false, NULL);
-INSERT INTO offering (offeringid, subject, semesterid, description, url, groups_student_permissions, show_worksheet_marks, worksheet_cutoff) VALUES (3, 1, 3, 'This subject will introduce you to the basics of IVLE, again.', 'http://www.ivle.org/example/101', 'none', false, NULL);
-INSERT INTO offering (offeringid, subject, semesterid, description, url, groups_student_permissions, show_worksheet_marks, worksheet_cutoff) VALUES (4, 3, 3, 'This subject will provide you with a working knowledge of advanced IVLE concepts.', 'http://www.ivle.org/example/201', 'none', false, NULL);
-INSERT INTO offering (offeringid, subject, semesterid, description, url, groups_student_permissions, show_worksheet_marks, worksheet_cutoff) VALUES (5, 2, 4, 'Enhancing your understanding of IVLE''s usage and operation, this subject will consolidate and expand your general IVLE knowledge, again.', 'http://www.ivle.org/example/102', 'none', false, NULL);
-INSERT INTO offering (offeringid, subject, semesterid, description, url, groups_student_permissions, show_worksheet_marks, worksheet_cutoff) VALUES (6, 4, 4, 'After undertaking this subject, you should be a master of all things IVLEy.', 'http://www.ivle.org/example/202', 'none', false, NULL);
+INSERT INTO offering (offeringid, subject, semesterid, description, url, groups_student_permissions) VALUES (1, 1, 1, 'This subject will introduce you to the basics of IVLE.', 'http://www.ivle.org/example/101', 'none');
+INSERT INTO offering (offeringid, subject, semesterid, description, url, groups_student_permissions) VALUES (2, 2, 2, 'Enhancing your understanding of IVLE''s usage and operation, this subject will consolidate and expand your general IVLE knowledge.', 'http://www.ivle.org/example/102', 'none');
+INSERT INTO offering (offeringid, subject, semesterid, description, url, groups_student_permissions) VALUES (3, 1, 3, 'This subject will introduce you to the basics of IVLE, again.', 'http://www.ivle.org/example/101', 'none');
+INSERT INTO offering (offeringid, subject, semesterid, description, url, groups_student_permissions) VALUES (4, 3, 3, 'This subject will provide you with a working knowledge of advanced IVLE concepts.', 'http://www.ivle.org/example/201', 'none');
+INSERT INTO offering (offeringid, subject, semesterid, description, url, groups_student_permissions) VALUES (5, 2, 4, 'Enhancing your understanding of IVLE''s usage and operation, this subject will consolidate and expand your general IVLE knowledge, again.', 'http://www.ivle.org/example/102', 'none');
+INSERT INTO offering (offeringid, subject, semesterid, description, url, groups_student_permissions) VALUES (6, 4, 4, 'After undertaking this subject, you should be a master of all things IVLEy.', 'http://www.ivle.org/example/202', 'none');
 
 
 ALTER TABLE offering ENABLE TRIGGER ALL;
@@ -431,11 +431,11 @@
 
 ALTER TABLE worksheet DISABLE TRIGGER ALL;
 
-INSERT INTO worksheet (worksheetid, offeringid, identifier, name, data, assessable, seq_no, format, published) VALUES (1, 2, 'worksheet1', 'Worksheet Basics', 'IVLE allows lecturers and tutors to create worksheets, which are presented to students, optionally, for assessment.
-
-Worksheets are reStructuredText (rich text) documents which can present students with information or tutorials, much like a textbook. For example, we might explain that "the ``print`` statement in Python lets you print text to the screen".
-
-We can use any reStructuredText markup, such as **bold** and `links <http://ivle.org>`_. We can also embed exercises. For example, we might invite students to "try out the ``print`` statement in the following exercise".
+INSERT INTO worksheet (worksheetid, offeringid, identifier, name, data, assessable, seq_no, format) VALUES (1, 2, 'worksheet1', 'Worksheet Basics', 'IVLE allows lecturers and tutors to create worksheets, which are presented to students, optionally, for assessment.
+
+Worksheets are reStructuredText (rich text) documents which can present students with information or tutorials, much like a textbook. For example, we might explain that "recursion is when a function calls itself".
+
+We can use any reStructuredText markup, such as **bold** and `links <http://ivle.org>`_. We can also embed exercises. For example, we might invite students to "try out recursion in the following exercise".
 
 Beginning a line with ``.. exercise:: <exercise-name>`` embeds an exercise in a worksheet, like this:
 
@@ -446,7 +446,7 @@
 Here is a second exercise. This one involves writing functions, and has multiple parts. The test suite will test each part individually.
 
 .. exercise:: factorial
-', true, 0, 'rst', true);
+', true, 0, 'rst');
 
 
 ALTER TABLE worksheet ENABLE TRIGGER ALL;
@@ -464,6 +464,8 @@
 ALTER TABLE worksheet_exercise ENABLE TRIGGER ALL;
 
 --
+
+--
 -- PostgreSQL database dump complete
 --
 

=== modified file 'ivle/database.py'
--- ivle/database.py	2010-02-24 11:48:39 +0000
+++ ivle/database.py	2010-02-23 04:16:34 +0000
@@ -325,8 +325,6 @@
     semester = Reference(semester_id, Semester.id)
     description = Unicode()
     url = Unicode()
-    show_worksheet_marks = Bool()
-    worksheet_cutoff = DateTime()
     groups_student_permissions = Unicode()
 
     enrolments = ReferenceSet(id, 'Enrolment.offering_id')
@@ -437,7 +435,6 @@
             newws.identifier = worksheet.identifier
             newws.name = worksheet.name
             newws.assessable = worksheet.assessable
-            newws.published = worksheet.published
             newws.data = worksheet.data
             newws.format = worksheet.format
             newws.offering = self
@@ -961,7 +958,6 @@
     identifier = Unicode()
     name = Unicode()
     assessable = Bool()
-    published = Bool()
     data = Unicode()
     seq_no = Int()
     format = Unicode()

=== modified file 'ivle/webapp/admin/breadcrumbs.py'
--- ivle/webapp/admin/breadcrumbs.py	2010-02-24 03:19:35 +0000
+++ ivle/webapp/admin/breadcrumbs.py	2010-02-17 08:57:40 +0000
@@ -37,45 +37,22 @@
 
     @property
     def text(self):
-        perms = self.context.get_permissions(self.req.user, self.req.config)
-        # Show nickname iff current user has permission to view this user
-        # (Else, show just the login name)
-        if 'view' in perms:
-            return self.context.nick
-        else:
-            return self.context.login
+        return self.context.nick
 
     @property
     def extra_breadcrumbs_before(self):
         return [UsersBreadcrumb()]
 
 
-class SubjectsBreadcrumb(object):
-    @property
-    def url(self):
-        return '/subjects'
-
-    @property
-    def text(self):
-        return 'Subjects'
-
 class SubjectBreadcrumb(object):
     def __init__(self, req, context):
         self.req = req
         self.context = context
 
     @property
-    def url(self):
-        return self.req.publisher.generate(self.context)
-
-    @property
     def text(self):
         return self.context.name
 
-    @property
-    def extra_breadcrumbs_before(self):
-        return [SubjectsBreadcrumb()]
-
 
 class OfferingBreadcrumb(object):
     def __init__(self, req, context):

=== modified file 'ivle/webapp/admin/subject.py'
--- ivle/webapp/admin/subject.py	2010-02-24 02:43:38 +0000
+++ ivle/webapp/admin/subject.py	2010-02-23 08:48:09 +0000
@@ -64,7 +64,6 @@
     '''The view of the list of subjects.'''
     template = 'templates/subjects.html'
     tab = 'subjects'
-    breadcrumb_text = "Subjects"
 
     def authorize(self, req):
         return req.user is not None
@@ -97,7 +96,6 @@
     def populate(self, req, ctx):
         ctx['req'] = req
         ctx['mediapath'] = media_url(req, CorePlugin, 'images/')
-        ctx['SubjectView'] = SubjectView
         ctx['SubjectEdit'] = SubjectEdit
         ctx['SemesterEdit'] = SemesterEdit
 
@@ -146,6 +144,9 @@
     def validator(self):
         return SubjectSchema()
 
+    def get_return_url(self, obj):
+        return '/subjects'
+
 
 class SubjectNew(SubjectFormView):
     """A form to create a subject."""
@@ -265,23 +266,6 @@
 
         return self.context
 
-class SubjectView(XHTMLView):
-    '''The view of the list of offerings in a given subject.'''
-    template = 'templates/subject.html'
-    tab = 'subjects'
-
-    def authorize(self, req):
-        return req.user is not None
-
-    def populate(self, req, ctx):
-        ctx['context'] = self.context
-        ctx['req'] = req
-        ctx['user'] = req.user
-        ctx['offerings'] = list(self.context.offerings)
-        ctx['permissions'] = self.context.get_permissions(req.user,req.config)
-        ctx['SubjectEdit'] = SubjectEdit
-        ctx['SubjectOfferingNew'] = SubjectOfferingNew
-
 
 class OfferingView(XHTMLView):
     """The home page of an offering."""
@@ -413,7 +397,6 @@
         ctx['subjects'] = req.store.find(Subject).order_by(Subject.name)
         ctx['semesters'] = req.store.find(Semester).order_by(
             Semester.year, Semester.semester)
-        ctx['force_subject'] = None
 
     def populate_state(self, state):
         state.existing_offering = self.context
@@ -453,7 +436,6 @@
         ctx['subjects'] = req.store.find(Subject).order_by(Subject.name)
         ctx['semesters'] = req.store.find(Semester).order_by(
             Semester.year, Semester.semester)
-        ctx['force_subject'] = None
 
     def populate_state(self, state):
         state.existing_offering = None
@@ -471,13 +453,6 @@
         req.store.add(new_offering)
         return new_offering
 
-class SubjectOfferingNew(OfferingNew):
-    """A form to create an offering for a given subject."""
-    # Identical to OfferingNew, except it forces the subject to be the subject
-    # in context
-    def populate(self, req, ctx):
-        super(SubjectOfferingNew, self).populate(req, ctx)
-        ctx['force_subject'] = self.context
 
 class OfferingCloneWorksheetsSchema(formencode.Schema):
     subject = formencode.All(
@@ -765,9 +740,7 @@
              (ApplicationRoot, ('subjects', '+new'), SubjectNew),
              (ApplicationRoot, ('subjects', '+new-offering'), OfferingNew),
              (ApplicationRoot, ('+semesters', '+new'), SemesterNew),
-             (Subject, '+index', SubjectView),
              (Subject, '+edit', SubjectEdit),
-             (Subject, '+new-offering', SubjectOfferingNew),
              (Semester, '+edit', SemesterEdit),
              (Offering, '+index', OfferingView),
              (Offering, '+edit', OfferingEdit),

=== modified file 'ivle/webapp/admin/templates/offering-form.html'
--- ivle/webapp/admin/templates/offering-form.html	2010-02-24 02:32:25 +0000
+++ ivle/webapp/admin/templates/offering-form.html	2010-02-15 09:09:12 +0000
@@ -11,14 +11,11 @@
           <py:if test="req.user.admin">
           <div>
             <label for="subject">Subject:</label>
-            <span py:if="force_subject">${force_subject.name} <input type="hidden" name="subject" value="${force_subject.short_name}" /></span>
-            <py:if test="force_subject is None">
-              <select id="subject" name="subject">
-                <option py:for="subject in subjects" value="${subject.short_name}">${subject.name}</option>
-              </select>
-              <span py:if="'subject' in errors" class="form_error">${errors.subject}.</span>
-              <a class="addaction" href="/subjects/+new">Create new subject</a>
-            </py:if>
+            <select id="subject" name="subject">
+              <option py:for="subject in subjects" value="${subject.short_name}">${subject.name}</option>
+            </select>
+            <span py:if="'subject' in errors" class="form_error">${errors.subject}.</span>
+            <a class="addaction" href="/subjects/+new">Create new subject</a>
           </div>
           <div>
             <label for="semester">Semester:</label>

=== modified file 'ivle/webapp/admin/templates/offering-new.html'
--- ivle/webapp/admin/templates/offering-new.html	2010-02-24 02:32:25 +0000
+++ ivle/webapp/admin/templates/offering-new.html	2010-02-15 09:18:56 +0000
@@ -5,7 +5,7 @@
     <title>New offering</title>
   </head>
   <body>
-    <h1>New offering<span py:if="force_subject"> &ndash; ${force_subject.name}</span></h1>
+    <h1>New offering</h1>
     <div py:with="submit_button_label = 'Create'"
          id="ivle_padding">
       <xi:include href="offering-form.html" />

=== removed file 'ivle/webapp/admin/templates/subject.html'
--- ivle/webapp/admin/templates/subject.html	2010-02-24 02:32:25 +0000
+++ ivle/webapp/admin/templates/subject.html	1970-01-01 00:00:00 +0000
@@ -1,35 +0,0 @@
-<html xmlns="http://www.w3.org/1999/xhtml"
-      xmlns:py="http://genshi.edgewall.org/">
-  <head>
-    <title>${context.name}</title>
-  </head>
-  <body>
-    <h1>${context.name}</h1>
-    <div id="ivle_padding">
-      <div class="contextactions">
-        <a py:if="'edit' in permissions"
-           class="editaction"
-           href="${req.publisher.generate(context, SubjectEdit)}">
-           Change details
-        </a>
-      </div>
-      <py:choose test="len(offerings) > 0">
-        <p py:when="True">This subject is offered in the following semesters:</p>
-        <p py:when="False">There are no offerings associated with this subject.</p>
-      </py:choose>
-      <ul py:if="len(offerings) > 0">
-        <li py:for="offering in offerings"
-            py:attrs="{'class': 'subject_current' if offering.semester.state == u'current' else None}">
-          <py:choose test="user.admin or offering.get_enrolment(user) is not None">
-            <a py:when="True" href="${req.publisher.generate(offering)}">${offering.semester.year}, semester ${offering.semester.semester}</a>
-            <span py:otherwise="">${offering.semester.year}, semester ${offering.semester.semester}</span>
-          </py:choose>
-        </li>
-      </ul>
-      <div class="horizontalactions" py:if="req.user.admin">
-        <a class="addaction" href="${req.publisher.generate(context, SubjectOfferingNew)}">Create new offering</a>
-        <a class="manageaction" href="/subjects/+manage">Manage subjects and semesters</a>
-      </div>
-    </div>
-  </body>
-</html>

=== modified file 'ivle/webapp/admin/templates/subjects-manage.html'
--- ivle/webapp/admin/templates/subjects-manage.html	2010-02-24 01:44:51 +0000
+++ ivle/webapp/admin/templates/subjects-manage.html	2010-02-15 08:49:58 +0000
@@ -12,7 +12,7 @@
           <thead><tr><th>Subject</th><th>Code</th><th>Actions</th></tr></thead>
           <tbody>
             <tr py:for="subject in subjects">
-              <td><a href="${req.publisher.generate(subject, SubjectView)}" title="Subject offerings">${subject.name}</a></td>
+              <td>${subject.name}</td>
               <td>${subject.code}</td>
               <td>
                 <a href="${req.publisher.generate(subject, SubjectEdit)}" title="Edit"><img src="${mediapath + 'interface/pencil.png'}" alt="Edit" /></a>

=== modified file 'ivle/webapp/admin/templates/user-edit.html'
--- ivle/webapp/admin/templates/user-edit.html	2010-02-24 01:38:33 +0000
+++ ivle/webapp/admin/templates/user-edit.html	2009-12-16 04:14:54 +0000
@@ -1,21 +1,21 @@
 <html xmlns="http://www.w3.org/1999/xhtml"
       xmlns:py="http://genshi.edgewall.org/">
   <head>
-    <title>Edit profile - ${context.nick}</title>
+    <title>Edit profile - ${user.nick}</title>
   </head>
   <body>
-    <h1>Edit profile of ${context.nick}</h1>
+    <h1>Edit profile of ${user.nick}</h1>
     <div id="ivle_padding">
       <div class="contextactions">
-        <a py:if="req.user.admin" class="manageaction" href="/~${context.login}/+admin">Administer user</a>
-        <a py:if="context.passhash" class="keyaction" href="/~${context.login}/+changepassword">Change password</a>
-        <a py:if="req.user.admin" class="keyaction" href="/~${context.login}/+resetpassword">Reset password</a>
+        <a py:if="req.user.admin" class="manageaction" href="/~${user.login}/+admin">Administer user</a>
+        <a py:if="user.passhash" class="keyaction" href="/~${user.login}/+changepassword">Change password</a>
+        <a py:if="req.user.admin" class="keyaction" href="/~${user.login}/+resetpassword">Reset password</a>
       </div>
       <p>
-        ${context.fullname} (<b>${context.login}</b><py:if test="context.studentid"> / ${context.studentid}</py:if>)
+        ${user.fullname} (<b>${user.login}</b><py:if test="user.studentid"> / ${user.studentid}</py:if>)
       </p>
     
-      <p py:if="context.admin">Privilege: <strong>IVLE administrator</strong></p>
+      <p py:if="user.admin">Privilege: <strong>IVLE administrator</strong></p>
 
       <form class="verticalform" action="" method="post">
         <div>
@@ -28,20 +28,19 @@
           <input type="text" name="email" id="email" size="40" />
           <span py:if="'email' in errors" class="form_error">${errors.email}</span>
         </div>
-        <div class="submit form_error" py:if="defined('error_value')" py:content="error_value" />
-        <div class="submit"><input type="submit" value="Save" /></div>
+        <p><input type="submit" value="Save Changes" /></p>
       </form>
 
-      <h3 py:if="context.pass_exp or context.acct_exp">Notices</h3>
-      <p py:if="context.pass_exp">
+      <h3 py:if="user.pass_exp or user.acct_exp">Notices</h3>
+      <p py:if="user.pass_exp">
         Your password will expire
-        <span title="${format_datetime(context.pass_exp)}">${format_datetime_short(context.pass_exp)}</span>.
+        <span title="${format_datetime(user.pass_exp)}">${format_datetime_short(user.pass_exp)}</span>.
         You should change it before then to avoid having your account
         disabled.
       </p>
-      <p py:if="context.acct_exp">
+      <p py:if="user.acct_exp">
         Your IVLE account will expire
-        <span title="${format_datetime(context.acct_exp)}">${format_datetime_short(context.acct_exp)}</span>.
+        <span title="${format_datetime(user.acct_exp)}">${format_datetime_short(user.acct_exp)}</span>.
       </p>
     </div>
   </body>

=== modified file 'ivle/webapp/admin/user.py'
--- ivle/webapp/admin/user.py	2010-02-24 01:38:33 +0000
+++ ivle/webapp/admin/user.py	2010-02-24 01:32:50 +0000
@@ -49,32 +49,41 @@
     email = formencode.validators.Email(not_empty=False,
                                         if_missing=None)
 
-class UserEditView(BaseFormView):
+class UserEditView(XHTMLView):
     """A form to change a user's details."""
     template = 'templates/user-edit.html'
     tab = 'users'
     permission = 'edit'
 
-    @property
-    def validator(self):
-        return UserEditSchema()
-
-    def get_default_data(self, req):
-        return {'nick': self.context.nick,
-                'email': self.context.email
-                }
-
-    def save_object(self, req, data):
-        self.context.nick = data['nick']
-        self.context.email = unicode(data['email']) if data['email'] \
-                             else None
-        return self.context
+    def filter(self, stream, ctx):
+        return stream | HTMLFormFiller(data=ctx['data'])
 
     def populate(self, req, ctx):
-        super(UserEditView, self).populate(req, ctx)
+        if req.method == 'POST':
+            data = dict(req.get_fieldstorage())
+            try:
+                validator = UserEditSchema()
+                data = validator.to_python(data, state=req)
+                self.context.nick = data['nick']
+                self.context.email = unicode(data['email']) if data['email'] \
+                                     else None
+                req.store.commit()
+                req.throw_redirect(req.uri)
+            except formencode.Invalid, e:
+                errors = e.unpack_errors()
+        else:
+            data = {'nick': self.context.nick,
+                    'email': self.context.email
+                   }
+            errors = {}
+
         ctx['format_datetime'] = ivle.date.make_date_nice
         ctx['format_datetime_short'] = ivle.date.format_datetime_for_paragraph
 
+        ctx['req'] = req
+        ctx['user'] = self.context
+        ctx['data'] = data
+        ctx['errors'] = errors
 
 class UserAdminSchema(formencode.Schema):
     admin = formencode.validators.StringBoolean(if_missing=False)
@@ -120,6 +129,7 @@
                                  if data['studentid'] else None
         return self.context
 
+
     def populate(self, req, ctx):
         super(UserAdminView, self).populate(req, ctx)
 

=== modified file 'ivle/webapp/filesystem/browser/media/specialhome.js'
--- ivle/webapp/filesystem/browser/media/specialhome.js	2010-02-24 04:57:52 +0000
+++ ivle/webapp/filesystem/browser/media/specialhome.js	2010-02-23 07:42:32 +0000
@@ -65,15 +65,8 @@
         var subject = subjects[i];
         var subjpath = subject.subj_short_name;
         // Header, with link to offering home page.
-        h3 = $('<h3><span class="subjname"></span><span style="font-weight: normal"><span class="semester"></span> &ndash; <a class="subjectaction">Subject home</a></span>');
-        h3.find('.subjname').text(subject.subj_name);
-        /* Non-current offerings need to show the semester, to avoid confusion
-         * about which offering we are talking about */
-        if (subject.state != "current")
-        {
-            h3.find('.semester').text(" (" + subject.year + ", semester "
-                                      + subject.semester + ")");
-        }
+        h3 = $('<h3><span></span> <span style="font-weight: normal">&ndash; <a class="subjectaction">Subject home</a></span>');
+        h3.find('span:first-child').text(subject.subj_name);
         h3.find('a').attr('href', subject.url);
         $(specialhomediv).append(h3);
     

=== modified file 'ivle/webapp/publisher/__init__.py'
--- ivle/webapp/publisher/__init__.py	2010-02-24 09:55:30 +0000
+++ ivle/webapp/publisher/__init__.py	2009-12-02 05:01:35 +0000
@@ -280,26 +280,20 @@
 
                 if view is not None:
                     return (obj, view, tuple(todo[remove:]))
-                # We have just one segment, but no view was found. Try
-                # appending the default view name.
-                elif len(todo) == 1:
-                    # Augment it with the default view name, and look it up.
-                    view = vnames.get((todo[0], self.default))
-                    if view is not None:
-                        return (obj, view, tuple(todo[2:]))
                 # Now we must check for deep views.
                 # A deep view is one that has a name consisting of
                 # multiple segments. It's messier than it could be, because
                 # we also allow omission of the final segment if it is the
                 # default view name.
                 elif len(todo) >= 2:
-                    for x in range(2, len(todo) + 1):
-                        view = vnames.get(tuple(todo[:x]))
-                        if view is not None:
-                            return (obj, view, tuple(todo[x:]))
-                    view = vnames.get(tuple(todo + [self.default]))
-                    if view is not None:
-                        return (obj, view, tuple())
+                    view = vnames.get(tuple(todo[:2]))
+                    if view is not None:
+                        return (obj, view, tuple(todo[2:]))
+                elif len(todo) == 1:
+                    # Augment it with the default view name, and look it up.
+                    view = vnames.get((todo[0], self.default))
+                    if view is not None:
+                        return (obj, view, tuple(todo[2:]))
 
             # If there are no segments left to use, or there are no routes, we
             # get out.

=== modified file 'ivle/webapp/publisher/test_publisher.py'
--- ivle/webapp/publisher/test_publisher.py	2010-02-24 09:51:04 +0000
+++ ivle/webapp/publisher/test_publisher.py	2009-12-02 05:01:35 +0000
@@ -94,15 +94,6 @@
 class OfferingAddProject(View):
     pass
 
-class OfferingWorksheets(View):
-    pass
-
-class OfferingWorksheetMarks(View):
-    pass
-
-class OfferingWorksheetCSVMarks(View):
-    pass
-
 def root_to_subject_or_user(root, name):
     if name.startswith('~'):
         return root.users.get(name[1:])
@@ -193,12 +184,6 @@
                           viewset='browser')
         self.rtr.add_view(Offering, ('+projects', '+index'), OfferingProjects,
                           viewset='browser')
-        self.rtr.add_view(Offering, ('+worksheets', '+index'),
-                          OfferingWorksheets, viewset='browser')
-        self.rtr.add_view(Offering, ('+worksheets', '+marks', '+index'),
-                          OfferingWorksheetMarks, viewset='browser')
-        self.rtr.add_view(Offering, ('+worksheets', '+marks', 'marks.csv'),
-                          OfferingWorksheetCSVMarks, viewset='browser')
 
     def testOneRoute(self):
         assert_equal(self.rtr.resolve('/info1'),
@@ -326,25 +311,6 @@
               OfferingProjects, ())
              )
 
-    def testAnotherDefaultDeepView(self):
-        assert_equal(self.rtr.resolve('/info1/2009/1/+worksheets'),
-             (self.r.subjects['info1'].offerings[(2009, 1)],
-              OfferingWorksheets, ())
-             )
-
-    def testReallyDeepView(self):
-        assert_equal(
-             self.rtr.resolve('/info1/2009/1/+worksheets/+marks/marks.csv'),
-             (self.r.subjects['info1'].offerings[(2009, 1)],
-              OfferingWorksheetCSVMarks, ())
-             )
-
-    def testDefaultReallyDeepView(self):
-        assert_equal(self.rtr.resolve('/info1/2009/1/+worksheets/+marks'),
-             (self.r.subjects['info1'].offerings[(2009, 1)],
-              OfferingWorksheetMarks, ())
-             )
-
     def testNamedRouteWithDeepView(self):
         assert_equal(self.rtr.resolve('/info1/2009/1/+projects/p1'),
              (self.r.subjects['info1'].offerings[(2009, 1)].projects['p1'],

=== modified file 'ivle/webapp/tutorial/__init__.py'
--- ivle/webapp/tutorial/__init__.py	2010-02-24 11:55:47 +0000
+++ ivle/webapp/tutorial/__init__.py	2010-02-23 09:28:32 +0000
@@ -314,7 +314,6 @@
         URLNameValidator(not_empty=True))
     name = formencode.validators.UnicodeString(not_empty=True)
     assessable = formencode.validators.StringBoolean(if_missing=False)
-    published = formencode.validators.StringBoolean(if_missing=False)
     data = formencode.validators.UnicodeString(not_empty=True)
     format = formencode.All(
         WorksheetFormatValidator(),
@@ -385,7 +384,6 @@
         new_worksheet.identifier = data['identifier']
         new_worksheet.name = data['name']
         new_worksheet.assessable = data['assessable']
-        new_worksheet.published = data['published']
         new_worksheet.data = data['data']
         new_worksheet.format = data['format']
 
@@ -411,7 +409,6 @@
             'identifier': self.context.identifier,
             'name': self.context.name,
             'assessable': self.context.assessable,
-            'published': self.context.published,
             'data': self.context.data,
             'format': self.context.format
             }
@@ -420,7 +417,6 @@
         self.context.identifier = data['identifier']
         self.context.name = data['name']
         self.context.assessable = data['assessable']
-        self.context.published = data['published']
         self.context.data = data['data']
         self.context.format = data['format']
 
@@ -488,7 +484,9 @@
         ctx['var_types'] = {
             'var': 'variable',
             'arg': 'function argument',
-            'exception': 'exception',
+            # XXX: wgrant 2010-01-29 bug=514160: Need to
+            # restore support for this.
+            #'exception': 'exception',
             }
         ctx['part_types'] = {
             'stdout': 'standard output',

=== modified file 'ivle/webapp/tutorial/templates/worksheet_form.html'
--- ivle/webapp/tutorial/templates/worksheet_form.html	2010-02-24 11:55:47 +0000
+++ ivle/webapp/tutorial/templates/worksheet_form.html	2010-02-11 08:49:47 +0000
@@ -19,11 +19,6 @@
           <span py:if="'assessable' in errors" class="form_error">${errors.assessable}</span>
         </div>
         <div>
-          <label for='worksheet_published'>Published:</label>
-          <input type='checkbox' name='published' id='worksheet_published' />
-          <span py:if="'published' in errors" class="form_error">${errors.published}</span>
-        </div>
-        <div>
           <label for='worksheet_format'>Format:</label>
           <select name='format' id='worksheet_format'>
             <py:for each="(display,name) in formats">

=== modified file 'ivle/webapp/tutorial/test/TestFramework.py'
--- ivle/webapp/tutorial/test/TestFramework.py	2010-02-24 10:39:23 +0000
+++ ivle/webapp/tutorial/test/TestFramework.py	2010-02-23 10:55:41 +0000
@@ -394,6 +394,9 @@
             elif var.var_type == "arg":
                 self.add_arg(var)
             elif var.var_type == "exception":
+                # XXX: wgrant 2010-01-29 bug=514160: Need to restore
+                # support for this.
+                raise AssertionError("Exception variables unsupported.")
                 self.add_exception(var)
         
         for test_case in suite.test_cases:
@@ -444,7 +447,7 @@
         except:
             raise TestCreationError("Invalid value for function argument: %s" %var.var_value)
 
-    def add_exception(self, var):
+    def add_exception(self, exception_name):
         self._allowed_exceptions.add(var.var_name)
         
     def add_part(self, test_part):
@@ -551,13 +554,12 @@
         if 'exception' in inspection:
             exception = inspection['exception']
             exception_name = type(exception).__name__
-            if exception_name not in self._allowed_exceptions:
-                raise(exception)
+            raise(exception)
 
         return {'code': string,
                 'result': None,
                 'globals': self._console.globals(),
-                'exception': exception_name,
+                'exception': exception_name, # Hmmm... odd? Is this right?
                 'stdout': self._console.stdout.read(),
                 'stderr': self._console.stderr.read(),
                 'modified_files': None}

=== modified file 'ivle/webapp/userservice/__init__.py'
--- ivle/webapp/userservice/__init__.py	2010-02-24 04:57:52 +0000
+++ ivle/webapp/userservice/__init__.py	2010-02-23 09:00:25 +0000
@@ -261,7 +261,6 @@
             'subj_short_name': e.offering.subject.short_name,
             'year':            e.offering.semester.year,
             'semester':        e.offering.semester.semester,
-            'state':           e.offering.semester.state,
             'groups':          [{'name': group.name,
                                  'nick': group.nick} for group in e.groups]
         })

=== removed file 'userdb/migrations/20100224-01.sql'
--- userdb/migrations/20100224-01.sql	2010-02-24 11:44:41 +0000
+++ userdb/migrations/20100224-01.sql	1970-01-01 00:00:00 +0000
@@ -1,7 +0,0 @@
-BEGIN;
-
-ALTER TABLE offering ADD COLUMN show_worksheet_marks BOOLEAN NOT NULL DEFAULT false;
-ALTER TABLE offering ADD COLUMN worksheet_cutoff TIMESTAMP;
-ALTER TABLE worksheet ADD COLUMN published BOOLEAN NOT NULL DEFAULT true;
-
-COMMIT;

=== modified file 'userdb/users.sql'
--- userdb/users.sql	2010-02-24 11:44:41 +0000
+++ userdb/users.sql	2010-02-23 08:55:42 +0000
@@ -64,8 +64,6 @@
     semesterid  INTEGER REFERENCES semester (semesterid) NOT NULL,
     description VARCHAR,
     url         VARCHAR,
-    show_worksheet_marks BOOLEAN NOT NULL DEFAULT false,
-    worksheet_cutoff TIMESTAMP,
     groups_student_permissions  VARCHAR NOT NULL DEFAULT 'none',
     CHECK (groups_student_permissions in ('none', 'invite', 'create')),
     UNIQUE (subject, semesterid)
@@ -229,7 +227,6 @@
     name        TEXT NOT NULL,
     data        TEXT NOT NULL,
     assessable  BOOLEAN NOT NULL,
-    published   BOOLEAN NOT NULL DEFAULT true,
     seq_no      INT4 NOT NULL,
     format      TEXT NOT NUll,
     UNIQUE (offeringid, identifier)

